import "file";

/*
 * Makes an index of the web from all the files provided.
 * Then allows the user to enter in a search query, and if 
 * a match is found from the web it will be returned to the user.
 */
function main() {
	var filenames = ["TheCatAndTheHat.txt", "HowAreGummyWormsMade.txt", "EricRobertsWiki.txt", "JerryCainCS110Homepage.txt", "IntroPhotography.txt"];
	var indexedWeb = IndexedWeb(filenames);

	var callback = function(query) {
		return indexedWeb.search(query);
	};
	console.requestInput("Enter your search query: ", callback);
}

/*
 * The IndexedWeb class takes an array of filenames, finds the most
 * frequent word in each file to use as the file's tag, and stores
 * a map from tag to files. It returns an object containing the functionality
 * to search the IndexedWeb given search queries. 
 */
function IndexedWeb(filenames) {
	var web_index = {};
	for (var i = 0; i < filenames.length; i++) {
		var tag = findMostFrequentWord(filenames[i]);
		console.log("filename: " + filename);
		console.log("tag: " + tag);
		web_index[tag] = filenames[i];
	}

	function findMostFrequentWord(filename) {
		words = File.read(filename).split(" "); 
		var word_counts = {};
		for (var word in words) {
			if (word_counts[word] === undefined) {
				word_counts[word] = 0;
			}
			word_counts[word]++;
		}
		var largest_key = undefined;
		var largest_value = undefined;
		for (var key in word_counts) {
			if (largest_key === undefined) {
				largest_key = key;
				largest_value = word_counts[key];
			} else {
				if (word_counts[key] > largest_value) {
					largest_key = key;
					largest_value = word_counts[key];
				}
			}
		}
		return largest_key;
	}

	return {
		search: function(search_query) {
			return web_index[search_query];
		}
	};
}
